#nawk script to display contents of seed.pop $Revision: 1.6 $
#
#WBL  5 Dec 2005 Add gifR_file
#WBL  4 Dec 2005 Allow ARG2 to be nnn-mmm
#WBL  3 Jun 2005 based on seed.awk r1.5

#WBL 26 Jun 2005 Test if GIF exists first: avoids error line 1..3 of seed.pop 
#                and get speed up(?)
#
#Inputs <seed via cmdline> seed.pop (only if image file must be created)

BEGIN {
    printf("Content-Type: image/gif\n\n");
#    printf("Content-Type: text/plain\n\n");
#    printf("%s<br>\n","ENVIRON");
#On www-cgi server ENVIRON is empty!
#    for(i in ENVIRON) {
#	printf("%s='%s'<br>\n",i,ENVIRON[i]);
#    }
#    printf("ARG=%s\n",ARGC);
#    printf("ARGV=\n");
#    for(i in ARGV) {
#	printf("%s='%s'<br>\n",i,ARGV[i]);
#    }
    
    error=0; #ok
    if(ARGC!=3) error=1;
    else if(index(ARGV[2],"QUERY_STRING=")!=1) error=2;
    else {
	QUERY_STRING=substr(ARGV[2],length("QUERY_STRING=")+1);
#	printf("'%s'\n",QUERY_STRING);
	n=split(QUERY_STRING,t,"[& \\t\\n]");
#	printf("n=%d\n",n);
#	for(i=1;i<=n;i++) printf("'%s'\n",t[i]);
	if(n==0) error=3;
	else {
	    n2=split(t[1],tt,"-");
	    if(n2<1||n2>2) error=5;
	    else if(n2==1) seed=0+t[1];
	    else           seed=0+tt[1]-tt[2];
#	    print "n2",n2,"seed", seed;
	    if(seed<=0) error=4;
	}
    }
#    print "error",error,"seed",seed;
    #only test for rotating GIF if endpop.bat called by snowflake.js
    if(n2>1 && file_exists(gifR_file(seed))) {
      s = sprintf("cat %s",gifR_file(seed));
      system(s);
      exit 0;
    }
    else if(file_exists(gif_file(seed))) {
      s = sprintf("cat %s",gif_file(seed));
      system(s);
      exit 0;
    }
}

(error==0 && (n=index($0,"|"))>23 && FNR==seed) {# || seed=9999) { 
#    print $0;
#    found++;
    input = substr($0,n+1);
    n2=split(input,t2);
    pheno="";
    for(i=1;i<=n2;i++) {pheno=sprintf("%s%s",pheno,t2[i]);}
    if(!file_exists(gif_file(seed))) {
	print pheno                > input_file(seed);
	close input_file(seed);
	s = sprintf("lsys.perl notwww <%s",input_file(seed));
	s = sprintf("%s\t| pl2ppm.perl              2>/dev/null",s);
	s = sprintf("%s\t| /cs/www/www/etc/ppmtogif 2>/dev/null",s);
	s = sprintf("%s\t| giftool -rgb 0,0,0",s);
	s = sprintf("%s\t>%s\n",s,gif_file(seed));
	s = sprintf("%schmod o+r %s\n",s,gif_file(seed));
	s = sprintf("%schmod o-w %s\n",s,gif_file(seed));
	s = sprintf("%s>>oneseed.log\n",s);
	#print s >> "oneseed.log";
	system(s);
	#print "status",ok >> "oneseed.log";
	#s = sprintf("cat %s>>oneseed.log",input_file(seed));
	s = sprintf("ls -l %s>>oneseed.log",gif_file(seed));
	#print s;
	system(s);
	s = sprintf("rm %s",input_file(seed));
	#print s;
	system(s);
    }#create GIF
    #s = sprintf("rm %s",input_file(seed));
    #system(s);
    #s = sprintf("ls -l %s",gif_file(seed));
    #print s;
    #system(s);
    s = sprintf("cat %s",gif_file(seed));
    #print s;
    system(s);
    exit 0;
}

END{
#    if(found==0) print FILENAME,"contains",FNR,"lines but not seed",seed
#try to clean up junk left previously -- no other guys may be active 
#    s = sprintf("rm %s",input_file("*"));
#   print s;
#    system(s);
}

function file_exists(name) {
####http://www.faqs.org/faqs/computer-lang/awk/faq/
    return (system("test -r " name) == 0)
}
function input_file(i) {
#    return sprintf("../public_html/pfeiffer/pop/wbl_%d.tmp",i);
    return sprintf("/tmp/wbl_%d.tmp",i);
}
function gifR_file(i) {
    return sprintf("../public_html/pfeiffer/pop/seed_%dR.gif",i);
}
function gif_file(i) {
    return sprintf("../public_html/pfeiffer/pop/seed_%d.gif",i);
}





