// Pfeiffer Menu controls #$Revision: 1.15 $
// W. B. Langdon
// http://www.cs.ucl.ac.uk/staff/W.Langdon
// Written on Feb 2004

//WBL 30 May 2005 Support display_inc_user()
//WBL 12 Apr 2004 Save, Clone and drag-drop set userfitness
//WBL 23 Mar 2004 Allow menus when running but freeze flake
//WBL  4 Mar 2004 For efficiency do not leave menues on flakes when not in use

//http://www.quirksmode.org/js/events_compinfo.html Event compatibility tables

//document.write("pfeiffer_menu2.js $Revision: 1.15 $");

function ID(I) {
  if(deleted[I]) return "deleted";
  if(age[I] < -1) return "eve";
  if(age[I] <  0) return "";
  return "("+Flake[I].width+"x"+Flake[I].height+")";
}

//http://www.cs.tut.fi/~jkorpela/forms/extraspace.html
function pulldown(i) {//returns HTML string
  return ""+
  "<DIV id= \"pulldown"+i+"\" STYLE=\"VISIBILITY:hidden\">"		+
  "<FORM name = \"pulldown"+i+"\" "				+
  "STYLE=\"margin-bottom:0; margin-top:0\" >"			+
  "<SELECT name=\"pulldown\" ONCHANGE=\"menuaction("+i+")\">"	+
  "<OPTION VALUE=\"id\">"+i+" "+ID(i)		+
  "<OPTION VALUE=\"save\">Save"			+
  "<OPTION VALUE=\"clone\">Clone"		+
  "<OPTION VALUE=\"delete\">Delete"		+
  "<OPTION VALUE=\"close\">Close"		+
  "</SELECT>"					+
  "<BR>"					+
  "<input type=text name=\"name\" size=6 value=\"name\" "	+
  "       ONCHANGE=\"menu_name("+i+")\">"	+
  "</FORM>"					+
  "</DIV>"					+
  "";
}

function menu_name(I) {
  changename(I,document.forms["pulldown"+I].name.value);
  document.forms["pulldown"+I].name.value = chromename(I);
  change_display[I] = true; if(display_flake(I)) change_display[I] = false;
}
function setuserfitness(I) { 
  fit[I].value = userfitness; //best possible
  display_inc_user();
}
function menuaction(I) {
  var k = document.forms["pulldown"+I ].elements[0].options.selectedIndex;
  var option = document.forms["pulldown"+I ].elements[0].options[k].value
  switch(option) {
  case "id"    : {//nop 
		   break;}
  case "save"  : { if(savechrome(I)) alert("Bad id "+I+", or deleted");
		   else setuserfitness(I);
		   break;}
  case "clone" : { if(clone(I)<0) alert("Already deleted or "+
				        "no suitable guy to overwrite");
		   else setuserfitness(I);
		   break;}
  case "delete": { deletechrome(I); 
		   break;}
  case "close" : { hide_menu(I); 
		   break;}
  default:	 { alert("BUG please report! "+option+" not supported")
		   break;}
  }//endswitch
  change_display[I] = true; if(display_flake(I)) change_display[I] = false;
  return true;
}

function hide_menu(I) {
  if(ns4up) return;
  freeze[I]=0;

  //We delete menus by getting main thread to redraw flake.
  //With snow.gif and grave.gif this will be delayed till replaced by
  //life flake. In all cases hide menu immediately.

  if(document["pulldown"+I]) {
    Border[I]="GREEN";  //force refresh (sometime)
    document["pulldown"+I].style.visibility="hidden";
  }
}
function hide_menu_all() {
  for(var i=0; i< no; i++) hide_menu(i);
}
function visible_menu(I) {
  if(ns4up) return;
  defaultStatus = "visible_menu("+I+")";
  freeze[I]=mousewait;
  if(!document.forms["pulldown"+I ]) {
    if (ie4up) document.all["dot"+I].innerHTML            += pulldown(I);
    if (ns6up) document.getElementById("dot"+I).innerHTML += pulldown(I);
    defaultStatus += ".";

    //make sure we never go to server
    document["pulldown"+I].onsubmit=new Function("return false;");

    var s = chromename(I);
    if(s!="") document["pulldown"+I].name.value=s;
  }
  document["pulldown"+I].style.visibility="visible";
}

function mouseover(I) {
  visible_menu(I);
  return true;
}

function mousedown(I) { //a little klunky with Mozilla. dx,dy left as zero
  if(ns4up) return true;
  isHot = I;
  if(ie4up) {
    e = event;
    isHotdx = e.clientX - (xp[isHot] + am[isHot]*Math.sin(dx[isHot]));
    isHotdy = e.clientY -  yp[isHot];
  }
  document.onmousemove=dd;
  return true;
}

function mouseup() { //also used by onmouseout
  isHot = -1;
  document.onmousemove=null;
  return true;
}

/*********************************************************************
http://codelifter.com/main/javascript/dragablelayer.html
==============================================================
Script:     Amazing Draggable Layer

Functions:  This script implements a draggable layer that
            can be used much like a popup window... but with-
            out the usual focus problems that popups often
            imply.  Also included are simple controls to show
            or hide the draggable layer. Compatible with
            NS4-7 & IE.
            
Comments:   The script is in two parts.  A JavaScript
            <script> to be placed in the <head> of the
            page; and a <div> layer that should be placed
            either immediately after the <body> tag or
            immediately before the </body> tag.
            
            There are *no* changes or setups required in the
            JavaScript script.
            
            Positioning, width, height, colors, fonts, etc.,
            as well as initial visibility are set in the
            layer portion of the script, in the body.
            
Notes:      Only a single instance of the script is allowed
            per page.            

Browsers:   NS4-7 & IE4 and later

Author:     etLux
==============================================================



STEP 1.
Inserting the JavaScript <script> In Your Page

Put the following <script> </script> in the head
section of your page.  

There are no setups or changes required.

*********************************************************************/

// Script Source: CodeLifter.com
// Copyright 2003
// Do not remove this header

//isIE=document.all; == ie4up
//isNN=!document.all&&document.getElementById; == ns6up 
//isN4=document.layers; == ns4up
var isHot=-1;
var isHotdx = 0;
var isHotdy = 0;
//var ddEnabled=false;

/*********************************************************************
#function ddInit(e){
#  var topDog=ie4up ? "BODY" : "HTML";
#  whichDog=ie4up ? document.all.theLayer : document.getElementById("theLayer");  
#  hotDog=ie4up ? event.srcElement : e.target;  
#  while (hotDog.id!="titleBar"&&hotDog.tagName!=topDog){
#    hotDog=ie4up ? hotDog.parentElement : hotDog.parentNode;
#  }  
#  if (hotDog.id=="titleBar"){
#    offsetx=ie4up ? event.clientX : e.clientX;
#    offsety=ie4up ? event.clientY : e.clientY;
#    nowX=parseInt(whichDog.style.left);
#    nowY=parseInt(whichDog.style.top);
#    ddEnabled=true;
#    document.onmousemove=dd;
#  }
#}
#
*********************************************************************/

function dd(e){
  if(isHot<0) return true;

  if(fit[isHot].last != -2) { 
    setuserfitness(isHot);
    fit[isHot].min   = -1; //not choosy
    fit[isHot].last  = -2; //nobody
    change_display[isHot] = true;
    if(display_flake(isHot)) change_display[isHot] = false;
  }

  if(ie4up) e = event;
  var x = e.clientX - isHotdx;
  var y = e.clientY - isHotdy;
  xp[isHot] = x - am[isHot]*Math.sin(dx[isHot]);
  yp[isHot] = y;
  moveto(isHot,x,y);
  return false;  
}

/*********************************************************************
#function ddN4(whatDog){
#  if (!ns4up) return;
#  N4=eval(whatDog);
#  N4.captureEvents(Event.MOUSEDOWN|Event.MOUSEUP);
#  N4.onmousedown=function(e){
#    N4.captureEvents(Event.MOUSEMOVE);
#    N4x=e.x;
#    N4y=e.y;
#  }
#  N4.onmousemove=function(e){
#    if (isHot){
#      N4.moveBy(e.x-N4x,e.y-N4y);
#      return false;
#    }
#  }
#  N4.onmouseup=function(){
#    N4.releaseEvents(Event.MOUSEMOVE);
#  }
#}
#
*********************************************************************/
