// output text mode colour portable bitmap $Revision: 1.4 $
// W. B. Langdon
// http://www.cs.essex.ac.uk/staff/W.Langdon
// Written on 16 April 2006 (based on lsys.js r1.25)

// --------------------
// Tested with Mozilla Rhino r1.6R2

//ppm see http://en2.wikipedia.org/wiki/Portable_Pixmap_File_Format
//        http://www-info2.informatik.uni-wuerzburg.de/mitarbeiter/wolfram/lehre/bildformate.html

function pbm_heading(width,height,comment) {
 return	"P3\n"+
	"#Generated "+new Date()+" "+comment.replace(/\n/g,"")+"\n"+
	width+"\n"+
	height+"\n"+
	"255";
}
function print_pbm(pixmap,width,height,cmap,comment){
  print(pbm_heading(width,height,comment));

  var colours = new Array((cmap)? cmap.length+2 : 2);
  colours[0] = "0 0 0";
  colours[1] = "255 255 255";
  for(var k=0; k<colours.length-2;k++) {
    colours[k+2] = ""+cmap[k][0]+" "+cmap[k][1]+" "+cmap[k][2];}

  for(var y = height-1 ; y >= 0; y--) {//start at top
  for(var x = 0 ; x < width; x++)     {//left to right
    if(pixmap[y] && pixmap[y][x]) print(colours[pixmap[y][x]]);
    else                          print(colours[0]);
  }}
}//end print_pbm
