#WBL 21 August 2004 $Revision: 1.7 $

#WBL 19 Aug 2005 Add command line l-system. Update cgi-bin following 
#conversion to support GIF in IE6 by running pfeiffer.js on sonic
#associated improvements to cron job processing
#WBL 17 Dec 2005 Remove feedback* Add seed3.cc, snowflake.js etc

cp -p public_html/pfeiffer_README.txt README.TXT

tar cvfh pfeiffer.tar	\
	public_html/pfeiffer.html	#start screen	\
	README.TXT	#simple doc	\
	public_html/Pnglet.js	#Convert bitmap to PNG format	\
	public_html/ftostring.js	#floating point to string	\
	public_html/glRotate.js	#OpenGL glRotate ported to JavaScript	\
	public_html/lsys.js		#Lindenmayer grammar processing	\
	public_html/seed.pop    #copy of global population	\
	public_html/pfeiffer_bugs.html	#bugs and work a rounds	\
	public_html/pfeiffer_display.js	#generate editable table	\
	public_html/pfeiffer_local.html	#PNG/XBM made in browser	\
	public_html/pfeiffer_menu.js	#flying menus	\
	public_html/pfeiffer_params.html	#parameter screen	\
	public_html/pfeiffer_summary.js #display saved, ticks display	\
	public_html/pfeiffer_save.js	#offline save of selected flaks	\
	public_html/pfeiffer_server.html	#GIFs made on server	\
	public_html/random_direction.js	#	\
\
	public_html/snowflake.js	#display flakes saved by users	\
	public_html/howtosnow.html	#documentation for snowflake.js	\
\
	public_html/lindenmayer.html	#doc for oneshot L-sys pfeiffer.js \
	public_html/pfeiffer.js		#command line L-sys interpreter	\
	public_html/js.jar		#Rhino JavaScript interpreter	\
\
	public_html/svg.svg	\
	public_html/billyame.gif	\
	public_html/getfirefox_88x31.gif	\
	public_html/grave.gif			\
	public_html/snow.gif			\
	public_html/to.gif			\
	public_html/koch3_green_3yellow.gif	\
	public_html/koch3.gif			\
\
	public_html/egp2004/poster.jpg	\
\
	public_html/pfeiffer/*.html	\
	public_html/pfeiffer/*.png	\
	public_html/pfeiffer/*.xbm	\
	public_html/pfeiffer/*.awk	\
	public_html/pfeiffer/*.bat	\
	public_html/pfeiffer/*.fig	\
	public_html/pfeiffer/firebird-0.6.1-screenshot.gif	\
	public_html/pfeiffer/firefox-0.8-screenshot.gif	\
	public_html/pfeiffer/mozilla-1.5-screenshot.gif	\
	public_html/pfeiffer/ie6.gif			\
	public_html/pfeiffer/seed_3.gif			\
	public_html/pfeiffer/world-ip_9_may_2006.jpg	\
\
	public_html/pfeiffer/pop/seed_1.gif	#example to create dir	\
\
#nolonger used	cgi-bin/feedback.bat#cgi script for user comments to feedback	\
	cgi-bin/giftool	    #compiled for sun   \
	cgi-bin/harvest.cc  #online cgi program to append to seed.pop	\
	cgi-bin/harvest2.cc #online cgi for fileUpload    to seed.pop	\
	cgi-bin/log_it.bat  #cgi-script to log data	\
	cgi-bin/log.awk	    #tool to analyse log	\
	cgi-bin/lsys.perl   #part of cgi-script to generate GIF	\
	cgi-bin/pl2ppm.perl #part of cgi-script to generate GIF	\
	cgi-bin/pop.awk	    #off line conversion of seed.pop to html	\
	cgi-bin/pop.bat     #off line conversion of seed.pop to html	\
	cgi-bin/pop.crontab #off line conversion of seed.pop to html	\
	cgi-bin/seed.awk    #part of online cgi-script to generate HTML from top of seed.pop	\
	cgi-bin/seed3.cc    #online cgi program to read from seed.pop	\
	cgi-bin/seed.pop    #global population	\
	cgi-bin/test.bat    #cgi-script to convert chromosome into GIF	\
	cgi-bin/test_js.awk #part of cgi-script to convert chromo to GIF\
	cgi-bin/test_js2.bat#rsh-script to convert chromosome into GIF	\
	cgi-bin/js_sonic #SpiderMonkey JavaScript-C interpreter compiled SUN \
	cgi-bin/rhino/pfeiffer.js #command line L-sys interpreter	\
	cgi-bin/rhino/pbm.js	  #partof command line L-sys interpreter\
	cgi-bin/append.awk  #part of rsh-script to convert chromo to GIF\
	cgi-bin/toppop.bat  #cgi-script to return HTML pages showing top of seed.pop	\
	cgi-bin/endpop.bat  #cgi-script to return GIF for specific seed	\
	cgi-bin/oneseed.bat #cgi-script to return GIF for specific seed	\
	cgi-bin/oneseed.awk #find or generate GIF for specific seed	\
	cgi-bin/rotate.bat  #cron job to randomly spin flakes		\
	cgi-bin/rotate.awk  #part of cron job to randomly spin flakes	\
\
	public_html/make_pfeiffer_kit.bat

rm -i README.TXT

gzip pfeiffer.tar
chmod o+r pfeiffer.tar.gz 
echo "Remember to move pfeiffer.tar.gz to public_html"

#you will need to install gifmerge on your www server or use existing server

