#nawk script analysis log and debug files $Revision: 1.3 $
#
#WBL 28 Jun 2003 based on log.awk
#WBL 27 Jan 2002
#
#Inputs 
#

BEGIN { 	
    if(script=="") script = "halloffame.bat";
    if(html=="")   html   = "halloffame.html";
    if(min=="")    min=20;
    if(mymachine=="") mymachine="solenoid.cs.ucl.ac.uk";

    print "#halloffame.awk $Revision: 1.3 $" > script;
    print ""                                  > script;

    print "<html><head>"                                       > html;
    print "<title>"                                            > html;
    print "Genetic Snowflakes 7 - Jan 2002 to 28 June 2003"    > html;
    print "</title>"                                           > html;
    print "<!--halloffame.awk $Revision: 1.3 $!-->"            > html;
    print "<body BGCOLOR=\"#7f7f7f\" LINK=\"#0000ff\""         > html;
    print " ALINK=\"#00ff00\" VLINK=\"#ff0000\""               > html;
    print " TEXT=\"#000000\">"                                 > html;
    print "</head><body>"                                      > html;
    print "<center>"                                           > html;
    print "<table>"                                            > html;
    print "<caption><font size=+5>Hall of Fame"                > html;
    print "</font></caption>"                                  > html;
    print "<tr><th>count</th>"                                 > html;
    print "<th>flake</th>"                                     > html;
    print "<th colspan=5><a href="                             > html;
    print "\"http://www.246.dk/lsystems.html\">"               > html;
    print "L-System</a></th>"                                  > html;
    print "<th>moves</th>"                                     > html;
    print "<th>first discovered</th>"                          > html;
    print "</tr><tr>"                                          > html;
    print "<th></th><th></th>"                                 > html;
    print "<th align=left>angle</th>"                          > html;
    print "<th align=left>start string</th>"                   > html;
    print "<th>iterations</th>"                                > html;
    print "<th>step size</th>"                                 > html;
    print "<th>rules</th>"                                     > html;
    print "<th></th><th></th>"                                 > html;
    print "</tr>"                                              > html;
}

(length($0)>30) {
    if(substr($0,1,1)=="%") { #log
	n = index($0,";_:");
	t = substr($0,n+3);
	n2 = index(t,":_;");
	input = substr($0,n+3,n2-1);
#	printf("%3d %3d `%s` '%s' %s\n",n,n2,t,input,$0);
#	printf("%6d %3d %3d %s\t",FNR,n,n2,input);
#	printf("%s\n",input);
	tail = substr($0,n+3+n2-1+3);
#	printf("'%s'\n",tail);
	n_t2=split(tail,t2);
#	for(i=n_t2-5;i<=n_t2;i++) {printf("%s ",t2[i]);} printf("\n");
	pheno="";
	for(i=n_t2-5;i<=n_t2;i++) {pheno=sprintf("%s %s",pheno,t2[i]);}
	if(count[pheno]==0) {
            line[pheno]=FNR;
            split(substr($0,18,n-20),t2);
	    if(t2[4]!=mymachine) 
		first[pheno]=sprintf("%s %s %s %s",t2[1],t2[2],t2[3],t2[4]);
        }
	count[pheno]++;
	if(count[pheno]==min) {
	    print input > input_file(line[pheno]);
	    close input_file(line[pheno]);
	    printf("perl lsys.perl <%s",input_file(line[pheno])) > script;
#	    printf("\t| pl2ppm.perl 2>/dev/null")                > script;
	    printf("\t| pl2ppm.perl")                            > script;
#	    printf("\t|/cs/www/www/etc/ppmtogif 2>/dev/null")    > script;
	    printf("\t|ppmtogif")                                > script;
	    printf("\t| ../giftool -1")                          > script; 
	    printf("\t>%s\n",gif_file(line[pheno]))              > script;
	}
    }
}

END{
    close script;
    for(p in count) {
	if(count[p]>=min) {
	    printf("%5d %6d %s\n",count[p],line[p],p);

	    printf("<tr><td align=right>%3d</td",count[p])       > html;
	    printf("<td>")                                       > html;
	    printf("<img src=\"%s\"></td>\n",gif_file(line[p]))  > html;
	    split(p,t2);
	    for(i=1;i<=5;i++) { 
		split(t2[i],t3,"=");
		x=t3[2];
                #remove training 0 or default given by lsys.perl 15 Dec 2001
		if(i<5) {
		    if(int(x)==x) x=int(x); }
		else if(x=="")    x="('F', \"F-F++F-F\")";
		printf("<td>%s</td>\n",x)                        > html;
	    }
	    printf("<td>%s</td>\n",2000-t2[6])                   > html;
	    printf("<td>%s</td>",first[p])                       > html;
	    printf("</tr>\n")                                    > html;
	}
    }
    print "</table>"                                             > html;
    print "</center>"                                            > html;
    print "<p>Snow flakes logged more than ",min," times by "    > html;
    print "<a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/pfeiffer.html\">">html;
    print "pfeiffer.html</a><p>"                                 > html;
    print "<p><a href=\"overview.html\">Documentation.</a>"      > html;
    printf("<address>\n")                                        > html;
    printf("<a href=\"http://www.cs.ucl.ac.uk/staff/W.Langdon/\">") >html;
    printf("W.B.Langdon</a>\n")                                  > html;
    printf("</address></body></html>\n")                         > html;
    close html;
}

function input_file(i) {
    return sprintf("/tmp/wbl_%d.tmp",i);
}
function gif_file(i) {
    return sprintf("%d.gif",i);
}
